## oneclient-base 21.02.5.13.gf5ada89

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7.0)
if (POLICY CMP0148)
  cmake_policy(SET CMP0148 OLD)
endif()
if (POLICY CMP0153)
  cmake_policy(SET CMP0153 NEW)
endif()

project(oneclient C CXX)

option(CODE_COVERAGE "Enable code coverage (gcc only)." OFF)
option(STATIC_BOOST "Link Boost statically" OFF)
option(STATIC_LIBSTDCPP "Link libstdc++ statically" OFF)
option(WITH_CEPH "Include Ceph direct IO support" ON)
option(WITH_S3 "Include S3 direct IO support" ON)
option(WITH_SWIFT "Include Swift direct IO support" ON)
option(WITH_GLUSTERFS "Include GlusterFS direct IO support" ON)
option(WITH_WEBDAV "Include WebDAV and HTTP direct IO support" ON)
option(WITH_XROOTD "Include XRootD direct IO support" ON)
option(WITH_NFS "Include NFS direct IO support" ON)
option(WITH_ONECLIENT "Include oneclient binary" ON)
option(WITH_ONEBENCH "Include onebench binary" ON)
option(WITH_ONEDATAFS "Build onedatafs library" ON)
option(WITH_PYTHON2 "Build onedatafs for Python2" OFF)
option(WITH_PYTHON3 "Build onedatafs for Python3" ON)
option(WITH_ONES3 "Build ones3 binary" ON)

option(WITH_LIBDL "Link with libdl" ON)
option(WITH_LIBRT "Link with librt" ON)
option(WITH_TESTS "Build and run tests" ON)
option(ONEDATAFS_PYTHON_VERSION "Build onedatafs for specific Python version" "")
option(GIT_VERSION "Version of the Oneclient" "1.0.0")
option(FETCH_FOLLY "Fetch folly, fizz, wangle and proxygen and build in-place" OFF)

string(TOLOWER ${CMAKE_BUILD_TYPE} CMAKE_BUILD_TYPE_LOWERCASE)
message(STATUS "Build type: ${CMAKE_BUILD_TYPE_LOWERCASE}")

# CMake config
set(CMAKE_SKIP_INSTALL_ALL_DEPENDENCY True)
set(CMAKE_FIND_FRAMEWORK LAST)
set(CMAKE_POSITION_INDEPENDENT_CODE True)
set(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake ${PROJECT_SOURCE_DIR}/helpers/cmake)
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

set(WITH_FUSE_VERSION "3" CACHE STRING "Select Fuse version (2 or 3)")
set(CONDA_BUILD_PREFIX "" CACHE STRING "Conda build prefix")

# Maintain compatibility for ExternalProject_Add with older cmake versions
if(CMAKE_MAJOR_VERSION GREATER_EQUAL 3 AND CMAKE_MINOR_VERSION GREATER_EQUAL 19)
cmake_policy(SET CMP0114 OLD)
endif()

set(LIB_INSTALL_DIR lib CACHE INTERNAL "")

include(FindLibraryUtils)
include(GNUInstallDirs)

# Version
include(version.txt OPTIONAL)
file(MAKE_DIRECTORY ${PROJECT_BINARY_DIR}/version)
configure_file(include/version.h.in ${PROJECT_BINARY_DIR}/version/version.h)

# Deps
add_subdirectory(deps/libmacaroons)
add_subdirectory(deps/libmacaroons-cpp)

if(CMAKE_BUILD_TYPE_LOWERCASE MATCHES "debug")
    find_package(PkgConfig REQUIRED)
    pkg_check_modules(DW REQUIRED IMPORTED_TARGET libdw)
    set(BACKWARD_CPP_LIBRARIES PkgConfig::DW)
    add_definitions(-DENABLE_BACKWARD_CPP)
    message(STATUS "Enabled backward-cpp with libraries: ${BACKWARD_CPP_LIBRARIES}")
endif()

# Setup fuse, on Linux default required version is >= 3
# On other platforms it is not yet supported
if(WITH_FUSE_VERSION MATCHES "2")
    message(STATUS "Checking for FUSE 2...")
    find_package(FUSE 2 REQUIRED)
    set(FUSE_USE_VERSION 30)
else()
    message(STATUS "Checking for FUSE 3...")
    SET(FUSE_FIND_VERSION 3)
    find_package(FUSE 3 REQUIRED)
    if(FUSE_VERSION_MINOR LESS 10)
        set(FUSE_USE_VERSION 31)
    else()
        set(FUSE_USE_VERSION 34)
    endif()
endif()
message(STATUS "Found Fuse version: ${FUSE_VERSION}")
message(STATUS "FUSE_USE_VERSION: ${FUSE_USE_VERSION}")

# Setup pthreads
message(STATUS "Checking for thread support...")
find_package(Threads REQUIRED)

# Setup Intel TBB
message(STATUS "Checking for Intel TBB...")
find_package(TBB REQUIRED)

# Setup glog
message(STATUS "Checking for glog...")
find_package(Glog REQUIRED)

# Setup CURL
message(STATUS "Checking for CURL...")
find_package(CURL REQUIRED)

# Setup OpenSSL
message(STATUS "Checking for OpenSSL...")
find_package(OpenSSL 1.1.0 REQUIRED)

# Setup NSS
message(STATUS "Checking for NSS...")
if(NOT (CONDA_BUILD_PREFIX STREQUAL ""))
    set(NSS_INCLUDE_DIRS "${CONDA_BUILD_PREFIX}/include/nss")
    set(NSS_LIBRARIES "${CONDA_BUILD_PREFIX}/lib/libssl3.so;${CONDA_BUILD_PREFIX}/lib/libsmime3.so;${CONDA_BUILD_PREFIX}/lib/libnss3.so;${CONDA_BUILD_PREFIX}/lib/libnssutil3.so;${CONDA_BUILD_PREFIX}/lib/libnspr4.so")
endif()
find_package(NSS REQUIRED)

# Setup POCO
find_library(POCO_UTIL PocoUtil)
find_library(POCO_NET PocoNet)
find_library(POCO_NET_SSL PocoNetSSL)
find_library(POCO_XML PocoXML)
find_library(POCO_JSON PocoJSON)
find_library(POCO_FOUNDATION PocoFoundation)
set(POCO_LIBRARIES
        ${POCO_UTIL}
        ${POCO_NET}
        ${POCO_NET_SSL}
        ${POCO_XML}
        ${POCO_JSON}
        ${POCO_FOUNDATION})

# Setup Folly
option(FOLLY_SHARED "Link folly shared library" ON)
message(STATUS "Checking for Folly...")
find_library(LIBEVENT_LIBRARY event)
find_library(IBERTY_LIBRARY iberty)
find_library(DOUBLE_CONVERSION_LIBRARY double-conversion)
if(NOT FETCH_FOLLY)
    find_package(Folly REQUIRED)
    find_package(Wangle REQUIRED)
    find_package(Fizz REQUIRED)
    find_library(PROXYGEN_LIBRARY proxygen REQUIRED)
    set(FOLLY_LIBRARIES
        ${FOLLY_LIBRARIES}
        ${WANGLE_LIBRARIES}
        ${LIBEVENT_LIBRARY}
        ${IBERTY_LIBRARY}
        ${FIZZ_LIBRARY}
        ${PROXYGEN_LIBRARY}
        ${DOUBLE_CONVERSION_LIBRARY})
    if(NOT FOLLY_SHARED)
        list(APPEND FOLLY_LIBRARIES unwind gflags)
    endif(NOT FOLLY_SHARED)
else(FETCH_FOLLY)
    include(ExternalProject)
    ExternalProject_Add(folly
        GIT_REPOSITORY    https://github.com/facebook/folly.git
        GIT_TAG           v2024.06.24.00
        INSTALL_DIR       ${CMAKE_BINARY_DIR}/contrib
        CMAKE_ARGS        "-DCMAKE_CXX_FLAGS='-D__STDC_FORMAT_MACROS=1 -fPIC';-DBUILD_TESTS=OFF;-DCMAKE_C_FLAGS='-Wl,-lrt';-DCMAKE_EXE_LINKER_FLAGS='-lrt';-DCMAKE_EXE_LINKER_FLAGS='-lrt';-DCMAKE_INSTALL_PREFIX=${CMAKE_BINARY_DIR}/contrib"
    )
    ExternalProject_Add_StepTargets(folly install)
    ExternalProject_Add(fizz
        GIT_REPOSITORY    https://github.com/facebookincubator/fizz.git
        GIT_TAG           v2024.06.24.00
        SOURCE_SUBDIR     fizz
        DEPENDS           folly-install
        INSTALL_DIR       ${CMAKE_BINARY_DIR}/contrib
        CMAKE_ARGS        "-DCMAKE_CXX_FLAGS='-D__STDC_FORMAT_MACROS=1 -fPIC';-DBUILD_TESTS=OFF;-DCMAKE_PREFIX_PATH=${CMAKE_BINARY_DIR}/contrib;-DCMAKE_INSTALL_PREFIX=${CMAKE_BINARY_DIR}/contrib"
    )
    ExternalProject_Add_StepTargets(fizz install)
    ExternalProject_Add(wangle
        GIT_REPOSITORY    https://github.com/facebook/wangle.git
        GIT_TAG           v2024.06.24.00
        SOURCE_SUBDIR     wangle
        DEPENDS           fizz-install
        INSTALL_DIR       ${CMAKE_BINARY_DIR}/contrib
        CMAKE_ARGS        "-DCMAKE_CXX_FLAGS='-D__STDC_FORMAT_MACROS=1 -fPIC';-DBUILD_TESTS=OFF;-DCMAKE_PREFIX_PATH=${CMAKE_BINARY_DIR}/contrib;-DCMAKE_INSTALL_PREFIX=${CMAKE_BINARY_DIR}/contrib"
    )
    ExternalProject_Add_StepTargets(wangle install)
    ExternalProject_Add(mvfst
        GIT_REPOSITORY    https://github.com/facebook/mvfst.git
        GIT_TAG           v2024.06.24.00
        DEPENDS           wangle-install
        INSTALL_DIR       ${CMAKE_BINARY_DIR}/contrib
        CMAKE_ARGS        "-DCMAKE_CXX_FLAGS='-D__STDC_FORMAT_MACROS=1 -fPIC';-DBUILD_TESTS=OFF;-DCMAKE_PREFIX_PATH=${CMAKE_BINARY_DIR}/contrib;-DCMAKE_INSTALL_PREFIX=${CMAKE_BINARY_DIR}/contrib"
    )
    ExternalProject_Add_StepTargets(mvfst install)
    ExternalProject_Add(proxygen
        GIT_REPOSITORY    https://github.com/facebook/proxygen.git
        GIT_TAG           v2024.06.24.00
        DEPENDS           mvfst-install
        INSTALL_DIR       ${CMAKE_BINARY_DIR}/contrib
        CMAKE_ARGS        "-DCMAKE_CXX_FLAGS='-D__STDC_FORMAT_MACROS=1 -fPIC';-DBUILD_TESTS=OFF;-DCMAKE_PREFIX_PATH=${CMAKE_BINARY_DIR}/contrib;-DCMAKE_INSTALL_PREFIX=${CMAKE_BINARY_DIR}/contrib"
    )
    ExternalProject_Add_StepTargets(proxygen install)
    set(FOLLY_INCLUDE_DIR ${CMAKE_BINARY_DIR}/contrib/include)
    set(FOLLY_LIBRARIES
        ${CMAKE_BINARY_DIR}/contrib/lib/libfolly.a
        ${CMAKE_BINARY_DIR}/contrib/lib/libfollybenchmark.a
        ${CMAKE_BINARY_DIR}/contrib/lib/libwangle.a
        ${LIBEVENT_LIBRARY}
        ${IBERTY_LIBRARY}
        ${CMAKE_BINARY_DIR}/contrib/lib/libfizz.a
        ${CMAKE_BINARY_DIR}/contrib/lib/libproxygen.a
        ${DOUBLE_CONVERSION_LIBRARY}
        gflags
        glog)
    if(NOT FOLLY_SHARED)
        list(APPEND FOLLY_LIBRARIES unwind gflags)
    endif(NOT FOLLY_SHARED)
endif(NOT FETCH_FOLLY)

# Setup Boost
message(STATUS "Checking for Boost components...")
set(Boost_USE_MULTITHREADED      ON)
set(Boost_USE_STATIC_RUNTIME     ${STATIC_LIBSTDCPP})
set(Boost_USE_STATIC_LIBS        ${STATIC_BOOST})
find_package(Boost COMPONENTS atomic chrono context date_time filesystem
                              iostreams log log_setup program_options regex
                              system thread REQUIRED)

# Setup libsodium
find_package(Sodium)

# Find which Python interpreters are available
if(WITH_PYTHON2)
  find_package(Python2)
endif(WITH_PYTHON2)

if(WITH_PYTHON3)
  find_package(Python3)
endif(WITH_PYTHON3)

# Setup helpers
set(HELPERS_DIR ${CMAKE_CURRENT_SOURCE_DIR}/helpers)

# Setup Asio
set(ASIO_INCLUDE_DIRS ${HELPERS_DIR}/deps/asio/asio/include)
# Setup cppmetrics
set(CPPMETRICS_INCLUDE_DIRS ${HELPERS_DIR}/deps/cppmetrics)
# Setup backward-cpp
set(BACKWARD_CPP_INCLUDE_DIRS ${HELPERS_DIR}/deps/backward-cpp)

# Setup spdlog and fmt
if(FOLLY_SHARED)
    find_library(FMT_LIBRARY NAMES libfmt.a fmt REQUIRED)
    find_library(SPDLOG_LIBRARY NAMES libspdlog.a spdlog REQUIRED)
    add_definitions(-DSPDLOG_COMPILED_LIB -DSPDLOG_FMT_EXTERNAL)
else(FOLLY_SHARED)
    find_library(FMT_LIBRARY NAMES fmt libfmt.a REQUIRED)
    find_library(SPDLOG_LIBRARY NAMES spdlog libspdlog.a REQUIRED)
endif(FOLLY_SHARED)

# Utility libs
find_library(LTDL_LIBRARY NAMES ltdl)
find_package(ZLIB)

if(WITH_LIBRT)
find_library(RT_LIBRARY rt)
endif(WITH_LIBRT)

if(WITH_LIBDL)
find_library(DL_LIBRARY dl)
endif(WITH_LIBDL)

# Rados library
if(WITH_CEPH)
    find_library(CEPHCOMMON_LIBRARY "ceph-common" NAMES "ceph-common" "libceph-common.so.2" "libceph-common.so.0" PATH_SUFFIXES "ceph")
    find_library(RADOS_LIBRARY rados)
    find_library(RADOSSTRIPER_LIBRARY radosstriper)
    get_filename_component(CEPHCOMMON_RPATH "${CEPHCOMMON_LIBRARY}" DIRECTORY)
endif(WITH_CEPH)

# AWS SDK library
if(WITH_S3)
    find_package(AWSSDK REQUIRED COMPONENTS s3)
    set(AWS_SDK_LIBRARIES
        ${AWSSDK_LINK_LIBRARIES}
        ${AWSSDK_PLATFORM_DEPS}
        ${CURL_LIBRARIES})
    add_definitions(-DWITH_S3=1)
    if(APPLE)
      add_definitions(-DS3_HAS_NO_V2_SUPPORT)
    endif(APPLE)
else(WITH_S3)
    add_definitions(-DWITH_S3=0)
endif(WITH_S3)

# Swift SDK library
if(WITH_SWIFT)
    find_library(SWIFT_SDK_LIBRARY Swift)
    find_library(POCO_UTIL PocoUtil)
    find_library(POCO_NET PocoNet)
    find_library(POCO_XML PocoXML)
    find_library(POCO_FOUNDATION PocoFoundation)
    set(SWIFT_SDK_LIBRARIES
        ${SWIFT_SDK_LIBRARY}
        ${POCO_UTIL}
        ${POCO_NET}
        ${POCO_XML}
        ${POCO_FOUNDATION})
endif(WITH_SWIFT)

# GlusterFS SDK library
if(WITH_GLUSTERFS)
    include(FindPkgConfig)
    if (PKG_CONFIG_FOUND)
        set(ENV{PKG_CONFIG_PATH} "/opt/oneclient/lib/x86_64-linux-gnu/pkgconfig:$ENV{PKG_CONFIG_PATH}")
        pkg_check_modules(GLUSTERFSAPI glusterfs-api>=6.0)
        if(NOT GLUSTERFSAPI_FOUND EQUAL 1)
            message(SEND_ERROR "pkg-config for glusterfs-api is missing.")
        else()
            add_definitions(-DWITH_GLUSTERFS=1)
            link_directories(${GLUSTERFSAPI_LIBDIR})
	    message(STATUS "GLUSTERFSAPI_LIBDIR=${GLUSTERFSAPI_LIBDIR}")
	    message(STATUS "GLUSTERFSAPI_LIBRARIES=${GLUSTERFSAPI_LIBRARIES}")
	    message(STATUS "GLUSTERFSAPI_LINK_LIBRARIES=${GLUSTERFSAPI_LINK_LIBRARIES}")
        endif()
    endif (PKG_CONFIG_FOUND)
else(WITH_GLUSTERFS)
    add_definitions(-DWITH_GLUSTERFS=0)
endif(WITH_GLUSTERFS)

=== Makefile ===
# distro for package building (oneof: xenial, centos-7-x86_64)
RELEASE               ?= 2102
DISTRIBUTION          ?= none

PKG_REVISION    ?= $(shell git describe --tags --always  --abbrev=7)
PKG_VERSION     ?= $(shell git describe --tags --always  --abbrev=7 | tr - .)
PKG_COMMIT      ?= $(shell git rev-parse HEAD)
HELPERS_COMMIT  ?= $(shell git -C helpers rev-parse HEAD)
PKG_BUILD       ?= 1
PKG_ID           = oneclient-base-$(PKG_VERSION)

FSONEDATAFS_VERSION ?= $(PKG_VERSION)

# Build with Ceph storge helper by default
WITH_CEPH         ?= ON
# Build with Swift storage helper by default
WITH_SWIFT        ?= ON
# Build with S3 storage helper by default
WITH_S3           ?= ON
# Build with GlusterFS storage helper by default
WITH_GLUSTERFS    ?= ON
# Build with WebDAV storage helper by default
WITH_WEBDAV       ?= ON
# Build with XRootD storage helper by default
WITH_XROOTD       ?= ON
# Build with NFS storage helper by default
WITH_NFS          ?= ON
# Build with onedatafs Python library
WITH_ONEDATAFS    ?= ON
# Build with ones3
WITH_ONES3        ?= ON
# Build with code coverage
WITH_COVERAGE     ?= ON
# Set Fuse version (2 or 3)
WITH_FUSE_VERSION ?= 3

# Oneclient FPM packaging variables
PATCHELF_DOCKER_IMAGE   ?= docker.onedata.org/patchelf:0.9
FPM_DOCKER_IMAGE        ?= docker.onedata.org/fpm:1.9.3
GLUSTERFS_VERSION       ?= 7.2
ONECLIENT_FPMPACKAGE_TMP := package_fpm

# Detect compilation on CentOS using Software Collections environment
ifeq ($(shell awk -F= '/^ID=/{print $$2}' /etc/os-release), "centos")
		OPENSSL_ROOT_DIR ?= /opt/onedata/onedata2102/root/usr
		TBB_INSTALL_DIR ?= /opt/onedata/onedata2102/root/usr
endif

.PHONY: all
all: debug test

.PRECIOUS: %/CMakeCache.txt
%/CMakeCache.txt: **/CMakeLists.txt test/integration/* test/integration/**/* \
                  helpers/test/integration/* helpers/test/integration/**
	mkdir -p $*
	cd $* && cmake -GNinja -DCMAKE_BUILD_TYPE=$* \
	                       -DFETCH_FOLLY=${FETCH_FOLLY} \
	                       -DGIT_VERSION=${PKG_REVISION} \
	                       -DGIT_COMMIT=${PKG_COMMIT} \
	                       -DGIT_HELPERS_COMMIT=${HELPERS_COMMIT} \
	                       -DCODE_COVERAGE=${WITH_COVERAGE} \
	                       -DWITH_CEPH=${WITH_CEPH} \
	                       -DWITH_SWIFT=${WITH_SWIFT} \
	                       -DWITH_S3=${WITH_S3} \
	                       -DWITH_GLUSTERFS=${WITH_GLUSTERFS} \
	                       -DWITH_WEBDAV=${WITH_WEBDAV} \
	                       -DWITH_XROOTD=${WITH_XROOTD} \
	                       -DWITH_NFS=${WITH_NFS} \
	                       -DWITH_ONEDATAFS=${WITH_ONEDATAFS} \
	                       -DWITH_ONES3=${WITH_ONES3} \
	                       -DWITH_FUSE_VERSION=${WITH_FUSE_VERSION} \
	                       -DCMAKE_INSTALL_PREFIX=${PWD}/debug/PREFIX \
	                       -DTBB_INSTALL_DIR=${TBB_INSTALL_DIR} \
	                       -DOPENSSL_ROOT_DIR=${OPENSSL_ROOT_DIR} ..
	touch $@

%/build-native:
	mkdir -p _build
	cd _build && cmake -DCMAKE_BUILD_TYPE=$* \
			-DFETCH_FOLLY=${FETCH_FOLLY} \
			-DGIT_VERSION=${PKG_VERSION} \
			-DCODE_COVERAGE=OFF \
			-DWITH_CEPH=${WITH_CEPH} \
			-DWITH_SWIFT=${WITH_SWIFT} \
			-DWITH_S3=${WITH_S3} \
			-DWITH_GLUSTERFS=${WITH_GLUSTERFS} \
			-DWITH_WEBDAV=${WITH_WEBDAV} \
			-DWITH_XROOTD=${WITH_XROOTD} \
			-DWITH_NFS=${WITH_NFS} \
			-DWITH_ONECLIENT=ON \
			-DWITH_ONEBENCH=ON \
			-DWITH_ONES3=${WITH_ONES3} \
			-DWITH_ONEDATAFS=OFF \
			-DWITH_FUSE_VERSION=${WITH_FUSE_VERSION} \
			-DFOLLY_SHARED=ON \
			-DWITH_LIBDL=ON \
			-DWITH_LIBRT=ON \
			-DWITH_TESTS=OFF \
			-DBoost_NO_BOOST_CMAKE=ON \
			-DCMAKE_INSTALL_PREFIX=${PREFIX} \
			.. && \
	make -j8 oneclient VERBOSE=1 && \
	make -j8 onebench VERBOSE=1

##
## Submodules
##

submodules:
	git submodule sync --recursive ${submodule}
	git submodule update --init --recursive ${submodule}


.PHONY: phony
phony:

%/oneclient: %/CMakeCache.txt phony
	cmake --build $* --target oneclient

%/ones3: %/CMakeCache.txt phony
	cmake --build $* --target ones3

%/onebench: %/CMakeCache.txt phony
	cmake --build $* --target onebench

%/onedatafs-py2: %/CMakeCache.txt phony
	cmake --build $* --target onedatafs.py2

%/onedatafs-py3: %/CMakeCache.txt phony
	cmake --build $* --target onedatafs.py3

.PHONY: deb-info
deb-info: relwithdebinfo/oneclient

.PHONY: release
release: release/oneclient release/ones3 release/onebench release/onedatafs-py3

.PHONY: debug
debug: debug/oneclient debug/ones3 debug/onebench debug/onedatafs-py3

.PHONY: test
test: debug
ifdef ONEDATA_GIT_URL
	git config --global url."${ONEDATA_GIT_URL}".insteadOf "ssh://git@git.onedata.org:7999/vfs"
endif
	cmake --build debug
	cmake --build debug --target test

.PHONY: cunit
cunit: debug
	cmake --build debug
	cmake --build debug --target cunit

.PHONY: install
install: release
	ninja -C release install

.PHONY: docs
docs:
	@doxygen Doxyfile

#
# Coverage tests are collected from 2 types of tests:
# - Unit tests
# - Integration tests
#
# Unit test coverage results are managed by CMake and are collected
# in ./coverage/cunit/ subdirectory and should be generated after
# running cunit target.
#
# Integration tests coverage results have to be collected after
# each integration test (e.g. fslogic_test) and are stored in
# ./coverage/integration/TEST_NAME.
# A combined report containing the sum of coverage from individual
# integration tests can be generated using coverage_integration target
# and the result will be stored in ./coverage/integration/combined
#
.PHONY: coverage
coverage_cunit coverage:
	lcov --quiet --base-directory `pwd`/debug --directory `pwd`/debug --capture --output-file `pwd`/oneclient.info
	lcov --quiet --base-directory `pwd`/debug --remove `pwd`/oneclient.info 'test/*' '/usr/*' 'asio/*' '**/messages/*' \
	                                   'relwithdebinfo/*' 'debug/*' 'release/*' \
	                                   '**/helpers/*' 'deps/*' \
	     --output-file `pwd`/oneclient_cunit.info.cleaned
	find `pwd`/debug/ -name "*.gcda" -type f -delete
	genhtml -o `pwd`/coverage/cunit `pwd`/oneclient_cunit.info.cleaned
	@echo "Coverage written to `pwd`/coverage/cunit/index.html"

.PHONY: coverage/%
coverage/%:
	lcov --quiet --base-directory `pwd`/debug --directory `pwd`/debug --capture --output-file `pwd`/oneclient.info
	lcov --quiet --base-directory `pwd`/debug --remove `pwd`/oneclient.info 'test/*' '/usr/*' 'asio/*' '**/messages/*' \
	                                   'relwithdebinfo/*' 'debug/*' 'release/*' \
	                                   '**/helpers/*' 'deps/*' \
	     --output-file `pwd`/oneclient_integration_$*.info.cleaned
	find `pwd`/debug/ -name "*.gcda" -type f -delete
	genhtml -o `pwd`/coverage/integration/$* `pwd`/oneclient_integration_$*.info.cleaned
	@echo "Coverage written to `pwd`/coverage/integration/$*/index.html"

.PHONY: coverage_integration
coverage_integration:
	lcov --quiet -a `pwd`/oneclient_integration_events_test.info.cleaned \
		         -a `pwd`/oneclient_integration_fslogic_test.info.cleaned \
		         -o `pwd`/oneclient_integration_combined.info
	genhtml -o `pwd`/coverage/integration/combined `pwd`/oneclient_integration_combined.info
	@echo "Coverage written to `pwd`/coverage/integration/combined/index.html"

.PHONY: check_distribution
check_distribution:
ifeq ($(DISTRIBUTION), none)
	@echo "Please provide package distribution. Oneof: 'trusty', 'xenial', 'bionic', 'centos-7-x86_64'"
	@exit 1
else
	@echo "Building package for distribution $(DISTRIBUTION)"
endif

.PHONY: runbenchmark
runbenchmark: release
	cmake --build release --target benchmark

package/$(PKG_ID).tar.gz:
	mkdir -p package
	rm -rf package/$(PKG_ID)
	git archive --format=tar --prefix=$(PKG_ID)/ $(PKG_REVISION) | (cd package && tar -xf -)
	$(eval helpers_sha=$(shell git submodule status --recursive | grep "helpers "| awk '{print $$1;}'))
	cd helpers; git archive --format=tar --prefix=$(PKG_ID)/helpers/ $(helpers_sha) | (cd ../package && tar -xf -); cd ..
	$(eval clproto_sha=$(shell git submodule status --recursive | grep "helpers/clproto" | awk '{print $$1;}'))
	cd helpers/clproto; git archive --format=tar --prefix=$(PKG_ID)/helpers/clproto/ $(clproto_sha) | (cd ../../package && tar -xf -); cd ../..
	$(eval bamboos_sha=$(shell git submodule status --recursive | grep "helpers/bamboos" | awk '{print $$1;}'))
	cd helpers/bamboos; git archive --format=tar --prefix=$(PKG_ID)/helpers/bamboos/ $(bamboos_sha) | (cd ../../package && tar -xf -); cd ../..
	find package/$(PKG_ID) -depth -name ".git" -exec rm -rf {} \;
	echo "set(GIT_VERSION ${PKG_REVISION})" > package/$(PKG_ID)/version.txt
	tar -C package -czf package/$(PKG_ID).tar.gz $(PKG_ID)

.PHONY: conda/oneclient
conda/oneclient: SHELL:=/bin/bash
conda/oneclient: package/$(PKG_ID).tar.gz
	cp /tmp/.condarc $$HOME/.condarc
	cat $$HOME/.condarc
	mkdir -p package/conda
	mkdir -p package/conda-bld
	cp -R conda/oneclient package/conda/
	sed -i "s|<<PKG_VERSION>>|$(PKG_VERSION)|g" package/conda/oneclient/meta.yaml
	sed -i "s|<<PKG_SOURCE>>|../../$(PKG_ID).tar.gz|g" package/conda/oneclient/meta.yaml
	source /opt/conda/bin/activate base && \
		PKG_VERSION=$(PKG_VERSION) CONDA_BLD_PATH=$$PWD/package/conda-bld \
		conda build --user onedata-devel --token "${CONDA_TOKEN}" \
		${CONDA_BUILD_OPTIONS} package/conda/oneclient
	echo "onedata-devel/oneclient/$(PKG_VERSION)/download/linux-64/oneclient-$(PKG_VERSION)-py39.tar.bz2" >> conda-pkg-list.txt

.PHONY: conda/oneclient_centos6
conda/oneclient_centos6: SHELL:=/bin/bash
conda/oneclient_centos6: package/$(PKG_ID).tar.gz
	cp /tmp/.condarc-forge $$HOME/.condarc
	cat $$HOME/.condarc
	mkdir -p package/conda
	mkdir -p package/conda-bld
	cp -R conda/oneclient package/conda/
	sed -i "s|<<PKG_VERSION>>|$(PKG_VERSION)|g" package/conda/oneclient/meta.yaml
	sed -i "s|<<PKG_SOURCE>>|../../$(PKG_ID).tar.gz|g" package/conda/oneclient/meta.yaml
	sed -i 's|conda-forge::libfuse|onedata-centos6::libfuse =2.8.3|g' package/conda/oneclient/meta.yaml
	sed -i 's|protobuf.*$$|protobuf =3.8.0|g' package/conda/oneclient/meta.yaml
	sed -i 's|onedata::|onedata-centos6::|g' package/conda/oneclient/meta.yaml
	sed -i 's|DWITH_FUSE_VERSION=3|DWITH_FUSE_VERSION=2|g' package/conda/oneclient/build.sh
	sed -i '/run:/ { :l; n; s/^.*libfuse.*$$//; tx; bl; :x; N; s/\n//; bl }' package/conda/oneclient/meta.yaml
	source /opt/conda/bin/activate base && \
		PKG_VERSION=$(PKG_VERSION) CONDA_BLD_PATH=$$PWD/package/conda-bld \
		conda build --user onedata-centos6-devel --token "${CONDA_TOKEN}" \
		${CONDA_BUILD_OPTIONS} package/conda/oneclient
	echo "onedata-centos6-devel/oneclient/$(PKG_VERSION)/download/linux-64/oneclient-$(PKG_VERSION)-py39.tar.bz2" >> conda-pkg-list.txt

.PHONY: conda/onedatafs
conda/onedatafs: SHELL:=/bin/bash
conda/onedatafs: package/$(PKG_ID).tar.gz
	cp /tmp/.condarc $$HOME/.condarc
	cat $$HOME/.condarc
	mkdir -p package/conda
	mkdir -p package/conda-bld
	cp -R conda/onedatafs package/conda/
	sed -i "s|<<PKG_VERSION>>|$(PKG_VERSION)|g" package/conda/onedatafs/meta.yaml
	sed -i "s|<<PKG_SOURCE>>|../../$(PKG_ID).tar.gz|g" package/conda/onedatafs/meta.yaml
	source /opt/conda/bin/activate base && \
		PKG_VERSION=$(PKG_VERSION) CONDA_BLD_PATH=$$PWD/package/conda-bld \
		conda build --user onedata-devel --token "${CONDA_TOKEN}" \
		${CONDA_BUILD_OPTIONS} package/conda/onedatafs
	echo "onedata-devel/onedatafs/$(PKG_VERSION)/download/linux-64/onedatafs-$(PKG_VERSION)-py39.tar.bz2" >> conda-pkg-list.txt

.PHONY: deb
deb: check_distribution package/$(PKG_ID).tar.gz
	rm -rf package/packages && mkdir -p package/packages
	mv -f package/$(PKG_ID).tar.gz package/oneclient-base_$(PKG_VERSION).orig.tar.gz

	cp -R pkg_config/debian package/$(PKG_ID)/
	patch -d package/$(PKG_ID)/ -p1 -i pkg_config/$(DISTRIBUTION).patch
	sed -i "s/{{version}}/$(PKG_VERSION)/g" package/$(PKG_ID)/debian/changelog
	sed -i "s/{{build}}/$(PKG_BUILD)/g" package/$(PKG_ID)/debian/changelog

=== test/CMakeLists.txt ===
add_library(clientShared SHARED ${CLIENT_SOURCES})
target_link_libraries(clientShared PUBLIC ${CLIENT_LIBRARIES})

set(BUILD_INTEGRATION_TESTS TRUE CACHE BOOL "Enable building integration tests")
if(BUILD_INTEGRATION_TESTS)
    add_subdirectory(integration)
    add_subdirectory(onenv_tests)
endif()

add_subdirectory(unit)
add_subdirectory(benchmark)

## oneclient-base 21.02.8.58.g49d5da0

=== debian/changelog ===
oneclient-base (21.02.8.58.g49d5da0-1~focal) focal; urgency=low

  * Build from 21.02.8.58.g49d5da0

 -- Onedata Package Maintainer <support@onedata.org>  Fri, 24 Oct 2025 20:02:16 +0200

## oneclient-base 21.02.8.63.g20cd0af

=== CMakeLists.txt ===
--- 
+++ 
@@ -7,6 +7,10 @@
 endif()
 
 project(oneclient C CXX)
+
+set(CMAKE_CXX_STANDARD 17)
+set(CMAKE_CXX_STANDARD_REQUIRED ON)
+set(CMAKE_CXX_EXTENSIONS OFF)
 
 option(CODE_COVERAGE "Enable code coverage (gcc only)." OFF)
 option(STATIC_BOOST "Link Boost statically" OFF)
@@ -162,7 +166,7 @@
         GIT_REPOSITORY    https://github.com/facebook/folly.git
         GIT_TAG           v2024.06.24.00
         INSTALL_DIR       ${CMAKE_BINARY_DIR}/contrib
-        CMAKE_ARGS        "-DCMAKE_CXX_FLAGS='-D__STDC_FORMAT_MACROS=1 -fPIC';-DBUILD_TESTS=OFF;-DCMAKE_C_FLAGS='-Wl,-lrt';-DCMAKE_EXE_LINKER_FLAGS='-lrt';-DCMAKE_EXE_LINKER_FLAGS='-lrt';-DCMAKE_INSTALL_PREFIX=${CMAKE_BINARY_DIR}/contrib"
+        CMAKE_ARGS        "-DCMAKE_CXX_FLAGS='-D__STDC_FORMAT_MACROS=1 -fPIC -Wno-address';-DBUILD_TESTS=OFF;-DCMAKE_C_FLAGS='-Wl,-lrt';-DCMAKE_EXE_LINKER_FLAGS='-lrt';-DCMAKE_EXE_LINKER_FLAGS='-lrt';-DCMAKE_INSTALL_PREFIX=${CMAKE_BINARY_DIR}/contrib"
     )
     ExternalProject_Add_StepTargets(folly install)
     ExternalProject_Add(fizz
@@ -171,7 +175,7 @@
         SOURCE_SUBDIR     fizz
         DEPENDS           folly-install
         INSTALL_DIR       ${CMAKE_BINARY_DIR}/contrib
-        CMAKE_ARGS        "-DCMAKE_CXX_FLAGS='-D__STDC_FORMAT_MACROS=1 -fPIC';-DBUILD_TESTS=OFF;-DCMAKE_PREFIX_PATH=${CMAKE_BINARY_DIR}/contrib;-DCMAKE_INSTALL_PREFIX=${CMAKE_BINARY_DIR}/contrib"
+        CMAKE_ARGS        "-DCMAKE_CXX_FLAGS='-D__STDC_FORMAT_MACROS=1 -fPIC -Wno-address';-DBUILD_TESTS=OFF;-DCMAKE_PREFIX_PATH=${CMAKE_BINARY_DIR}/contrib;-DCMAKE_INSTALL_PREFIX=${CMAKE_BINARY_DIR}/contrib"
     )
     ExternalProject_Add_StepTargets(fizz install)
     ExternalProject_Add(wangle
@@ -180,7 +184,7 @@
         SOURCE_SUBDIR     wangle
         DEPENDS           fizz-install
         INSTALL_DIR       ${CMAKE_BINARY_DIR}/contrib
-        CMAKE_ARGS        "-DCMAKE_CXX_FLAGS='-D__STDC_FORMAT_MACROS=1 -fPIC';-DBUILD_TESTS=OFF;-DCMAKE_PREFIX_PATH=${CMAKE_BINARY_DIR}/contrib;-DCMAKE_INSTALL_PREFIX=${CMAKE_BINARY_DIR}/contrib"
+        CMAKE_ARGS        "-DCMAKE_CXX_FLAGS='-D__STDC_FORMAT_MACROS=1 -fPIC -Wno-address';-DCMAKE_PREFIX_PATH=${CMAKE_BINARY_DIR}/contrib;-DCMAKE_INSTALL_PREFIX=${CMAKE_BINARY_DIR}/contrib;-DBUILD_TESTS=OFF;-DBUILD_EXAMPLES=OFF;-DCMAKE_CROSSCOMPILING=ON"
     )
     ExternalProject_Add_StepTargets(wangle install)
     ExternalProject_Add(mvfst
@@ -188,7 +192,7 @@
         GIT_TAG           v2024.06.24.00
         DEPENDS           wangle-install
         INSTALL_DIR       ${CMAKE_BINARY_DIR}/contrib
-        CMAKE_ARGS        "-DCMAKE_CXX_FLAGS='-D__STDC_FORMAT_MACROS=1 -fPIC';-DBUILD_TESTS=OFF;-DCMAKE_PREFIX_PATH=${CMAKE_BINARY_DIR}/contrib;-DCMAKE_INSTALL_PREFIX=${CMAKE_BINARY_DIR}/contrib"
+        CMAKE_ARGS        "-DCMAKE_CXX_FLAGS='-D__STDC_FORMAT_MACROS=1 -fPIC -Wno-address';-DBUILD_TESTS=OFF;-DCMAKE_PREFIX_PATH=${CMAKE_BINARY_DIR}/contrib;-DCMAKE_INSTALL_PREFIX=${CMAKE_BINARY_DIR}/contrib"
     )
     ExternalProject_Add_StepTargets(mvfst install)
     ExternalProject_Add(proxygen
@@ -196,17 +200,59 @@
         GIT_TAG           v2024.06.24.00
         DEPENDS           mvfst-install
         INSTALL_DIR       ${CMAKE_BINARY_DIR}/contrib
-        CMAKE_ARGS        "-DCMAKE_CXX_FLAGS='-D__STDC_FORMAT_MACROS=1 -fPIC';-DBUILD_TESTS=OFF;-DCMAKE_PREFIX_PATH=${CMAKE_BINARY_DIR}/contrib;-DCMAKE_INSTALL_PREFIX=${CMAKE_BINARY_DIR}/contrib"
+        CMAKE_ARGS        "-DCMAKE_CXX_FLAGS='-D__STDC_FORMAT_MACROS=1 -fPIC -Wno-address';-DBUILD_TESTS=OFF;-DCMAKE_PREFIX_PATH=${CMAKE_BINARY_DIR}/contrib;-DCMAKE_INSTALL_PREFIX=${CMAKE_BINARY_DIR}/contrib"
     )
     ExternalProject_Add_StepTargets(proxygen install)
     set(FOLLY_INCLUDE_DIR ${CMAKE_BINARY_DIR}/contrib/include)
     set(FOLLY_LIBRARIES
+        ${CMAKE_BINARY_DIR}/contrib/lib/libwangle.a
         ${CMAKE_BINARY_DIR}/contrib/lib/libfolly.a
         ${CMAKE_BINARY_DIR}/contrib/lib/libfollybenchmark.a
         ${CMAKE_BINARY_DIR}/contrib/lib/libwangle.a
         ${LIBEVENT_LIBRARY}
         ${IBERTY_LIBRARY}
         ${CMAKE_BINARY_DIR}/contrib/lib/libfizz.a
+        ${CMAKE_BINARY_DIR}/contrib/lib/libmvfst_async_udp_socket.a
+        ${CMAKE_BINARY_DIR}/contrib/lib/libmvfst_batch_writer.a
+        ${CMAKE_BINARY_DIR}/contrib/lib/libmvfst_buf_accessor.a
+        ${CMAKE_BINARY_DIR}/contrib/lib/libmvfst_bufutil.a
+        ${CMAKE_BINARY_DIR}/contrib/lib/libmvfst_cc_algo.a
+        ${CMAKE_BINARY_DIR}/contrib/lib/libmvfst_client.a
+        ${CMAKE_BINARY_DIR}/contrib/lib/libmvfst_codec.a
+        ${CMAKE_BINARY_DIR}/contrib/lib/libmvfst_codec_decode.a
+        ${CMAKE_BINARY_DIR}/contrib/lib/libmvfst_codec_packet_number_cipher.a
+        ${CMAKE_BINARY_DIR}/contrib/lib/libmvfst_codec_pktbuilder.a
+        ${CMAKE_BINARY_DIR}/contrib/lib/libmvfst_codec_pktrebuilder.a
+        ${CMAKE_BINARY_DIR}/contrib/lib/libmvfst_codec_types.a
+        ${CMAKE_BINARY_DIR}/contrib/lib/libmvfst_constants.a
+        ${CMAKE_BINARY_DIR}/contrib/lib/libmvfst_dsr_frontend.a
+        ${CMAKE_BINARY_DIR}/contrib/lib/libmvfst_dsr_types.a
+        ${CMAKE_BINARY_DIR}/contrib/lib/libmvfst_events.a
+        ${CMAKE_BINARY_DIR}/contrib/lib/libmvfst_exception.a
+        ${CMAKE_BINARY_DIR}/contrib/lib/libmvfst_fizz_client.a
+        ${CMAKE_BINARY_DIR}/contrib/lib/libmvfst_fizz_handshake.a
+        ${CMAKE_BINARY_DIR}/contrib/lib/libmvfst_flowcontrol.a
+        ${CMAKE_BINARY_DIR}/contrib/lib/libmvfst_handshake.a
+        ${CMAKE_BINARY_DIR}/contrib/lib/libmvfst_happyeyeballs.a
+        ${CMAKE_BINARY_DIR}/contrib/lib/libmvfst_looper.a
+        ${CMAKE_BINARY_DIR}/contrib/lib/libmvfst_loss.a
+        ${CMAKE_BINARY_DIR}/contrib/lib/libmvfst_observer.a
+        ${CMAKE_BINARY_DIR}/contrib/lib/libmvfst_qlogger.a
+        ${CMAKE_BINARY_DIR}/contrib/lib/libmvfst_server.a
+        ${CMAKE_BINARY_DIR}/contrib/lib/libmvfst_server_async_tran.a
+        ${CMAKE_BINARY_DIR}/contrib/lib/libmvfst_server_state.a
+        ${CMAKE_BINARY_DIR}/contrib/lib/libmvfst_state_ack_handler.a
+        ${CMAKE_BINARY_DIR}/contrib/lib/libmvfst_state_datagram_handler.a
+        ${CMAKE_BINARY_DIR}/contrib/lib/libmvfst_state_functions.a
+        ${CMAKE_BINARY_DIR}/contrib/lib/libmvfst_state_machine.a
+        ${CMAKE_BINARY_DIR}/contrib/lib/libmvfst_state_pacing_functions.a
+        ${CMAKE_BINARY_DIR}/contrib/lib/libmvfst_state_simple_frame_functions.a
+        ${CMAKE_BINARY_DIR}/contrib/lib/libmvfst_state_stream.a
+        ${CMAKE_BINARY_DIR}/contrib/lib/libmvfst_state_stream_functions.a
+        ${CMAKE_BINARY_DIR}/contrib/lib/libmvfst_transport.a
+        ${CMAKE_BINARY_DIR}/contrib/lib/libmvfst_transport_knobs.a
+        ${CMAKE_BINARY_DIR}/contrib/lib/libmvfst_transport_settings_functions.a
+        ${CMAKE_BINARY_DIR}/contrib/lib/libmvfst_xsk.a
         ${CMAKE_BINARY_DIR}/contrib/lib/libproxygen.a
         ${DOUBLE_CONVERSION_LIBRARY}
         gflags
@@ -234,96 +280,3 @@
 endif(WITH_PYTHON2)
 
 if(WITH_PYTHON3)
-  find_package(Python3)
-endif(WITH_PYTHON3)
-
-# Setup helpers
-set(HELPERS_DIR ${CMAKE_CURRENT_SOURCE_DIR}/helpers)
-
-# Setup Asio
-set(ASIO_INCLUDE_DIRS ${HELPERS_DIR}/deps/asio/asio/include)
-# Setup cppmetrics
-set(CPPMETRICS_INCLUDE_DIRS ${HELPERS_DIR}/deps/cppmetrics)
-# Setup backward-cpp
-set(BACKWARD_CPP_INCLUDE_DIRS ${HELPERS_DIR}/deps/backward-cpp)
-
-# Setup spdlog and fmt
-if(FOLLY_SHARED)
-    find_library(FMT_LIBRARY NAMES libfmt.a fmt REQUIRED)
-    find_library(SPDLOG_LIBRARY NAMES libspdlog.a spdlog REQUIRED)
-    add_definitions(-DSPDLOG_COMPILED_LIB -DSPDLOG_FMT_EXTERNAL)
-else(FOLLY_SHARED)
-    find_library(FMT_LIBRARY NAMES fmt libfmt.a REQUIRED)
-    find_library(SPDLOG_LIBRARY NAMES spdlog libspdlog.a REQUIRED)
-endif(FOLLY_SHARED)
-
-# Utility libs
-find_library(LTDL_LIBRARY NAMES ltdl)
-find_package(ZLIB)
-
-if(WITH_LIBRT)
-find_library(RT_LIBRARY rt)
-endif(WITH_LIBRT)
-
-if(WITH_LIBDL)
-find_library(DL_LIBRARY dl)
-endif(WITH_LIBDL)
-
-# Rados library
-if(WITH_CEPH)
-    find_library(CEPHCOMMON_LIBRARY "ceph-common" NAMES "ceph-common" "libceph-common.so.2" "libceph-common.so.0" PATH_SUFFIXES "ceph")
-    find_library(RADOS_LIBRARY rados)
-    find_library(RADOSSTRIPER_LIBRARY radosstriper)
-    get_filename_component(CEPHCOMMON_RPATH "${CEPHCOMMON_LIBRARY}" DIRECTORY)
-endif(WITH_CEPH)
-
-# AWS SDK library
-if(WITH_S3)
-    find_package(AWSSDK REQUIRED COMPONENTS s3)
-    set(AWS_SDK_LIBRARIES
-        ${AWSSDK_LINK_LIBRARIES}
-        ${AWSSDK_PLATFORM_DEPS}
-        ${CURL_LIBRARIES})
-    add_definitions(-DWITH_S3=1)
-    if(APPLE)
-      add_definitions(-DS3_HAS_NO_V2_SUPPORT)
-    endif(APPLE)
-else(WITH_S3)
-    add_definitions(-DWITH_S3=0)
-endif(WITH_S3)
-
-# Swift SDK library
-if(WITH_SWIFT)
-    find_library(SWIFT_SDK_LIBRARY Swift)
-    find_library(POCO_UTIL PocoUtil)
-    find_library(POCO_NET PocoNet)
-    find_library(POCO_XML PocoXML)
-    find_library(POCO_FOUNDATION PocoFoundation)
-    set(SWIFT_SDK_LIBRARIES
-        ${SWIFT_SDK_LIBRARY}
-        ${POCO_UTIL}
-        ${POCO_NET}
-        ${POCO_XML}
-        ${POCO_FOUNDATION})
-endif(WITH_SWIFT)
-
-# GlusterFS SDK library
-if(WITH_GLUSTERFS)
-    include(FindPkgConfig)
-    if (PKG_CONFIG_FOUND)
-        set(ENV{PKG_CONFIG_PATH} "/opt/oneclient/lib/x86_64-linux-gnu/pkgconfig:$ENV{PKG_CONFIG_PATH}")
-        pkg_check_modules(GLUSTERFSAPI glusterfs-api>=6.0)
-        if(NOT GLUSTERFSAPI_FOUND EQUAL 1)
-            message(SEND_ERROR "pkg-config for glusterfs-api is missing.")
-        else()
-            add_definitions(-DWITH_GLUSTERFS=1)
-            link_directories(${GLUSTERFSAPI_LIBDIR})
-	    message(STATUS "GLUSTERFSAPI_LIBDIR=${GLUSTERFSAPI_LIBDIR}")
-	    message(STATUS "GLUSTERFSAPI_LIBRARIES=${GLUSTERFSAPI_LIBRARIES}")
-	    message(STATUS "GLUSTERFSAPI_LINK_LIBRARIES=${GLUSTERFSAPI_LINK_LIBRARIES}")
-        endif()
-    endif (PKG_CONFIG_FOUND)
-else(WITH_GLUSTERFS)
-    add_definitions(-DWITH_GLUSTERFS=0)
-endif(WITH_GLUSTERFS)
-

## oneclient-base 21.02.8.63.g91dee77

=== debian/changelog ===
oneclient-base (21.02.8.63.g91dee77-1~focal) focal; urgency=low

  * Build from 21.02.8.63.g91dee77

 -- Onedata Package Maintainer <support@onedata.org>  Mon, 19 Jan 2026 12:48:25 +0100

## oneclient-base 21.02.8.112.g4b04e35

=== debian/changelog ===
oneclient-base (21.02.8.112.g4b04e35-1~focal) focal; urgency=low

  * Build from 21.02.8.112.g4b04e35

 -- Onedata Package Maintainer <support@onedata.org>  Fri, 25 Apr 2025 11:42:02 +0200

## oneclient-base 21.02.8.117.ga25bcbc

=== bench/CMakeLists.txt ===
find_package(GFlags REQUIRED)

set(ONEBENCH_LIBRARIES
    libmacaroons-cpp
    ${PLATFORM_EXTRA_LIBS}
    ${FUSE_LIBRARIES}
    ${Boost_LIBRARIES}
    ${SODIUM_LIBRARIES}
    ${PROTOBUF_LIBRARIES}
    ${NSS_LIBRARIES}
    ${FOLLY_LIBRARIES}
    ${HELPERS_LIBRARIES}
    ${OPENSSL_LIBRARIES}
    ${POCO_LIBRARIES}
    gflags
    glog
    unwind
    )

if(WITH_CEPH)
    list(APPEND ONEBENCH_LIBRARIES ${RADOSSTRIPER_LIBRARY} ${RADOS_LIBRARY} ${CEPHCOMMON_LIBRARY})
endif(WITH_CEPH)

if(WITH_S3)
    list(APPEND ONEBENCH_LIBRARIES ${AWS_SDK_LIBRARIES})
endif(WITH_S3)

if(WITH_SWIFT)
    list(APPEND ONEBENCH_LIBRARIES ${SWIFT_SDK_LIBRARIES})
endif(WITH_SWIFT)

if(WITH_GLUSTERFS)
    list(APPEND ONEBENCH_LIBRARIES ${GLUSTERFSAPI_LIBRARIES})
endif(WITH_GLUSTERFS)

if(WITH_XROOTD)
    list(APPEND ONEBENCH_LIBRARIES ${XROOTD_LIBRARIES})
endif(WITH_XROOTD)

if(WITH_NFS)
    list(APPEND ONEBENCH_LIBRARIES ${NFS_LIBRARIES})
endif(WITH_NFS)

add_executable(onebench
    "onebench.cc"
    "testRunner.cc"
    "testRunnerConfig.cc"
    "testWorkerRndWr.cc"
    "testWorkerRndRd.cc"
    "testWorkerRndRdHTTP.cc"
    $<TARGET_OBJECTS:helpers>
    $<TARGET_OBJECTS:clproto>)

add_dependencies(onebench helpers)

target_link_libraries(onebench PRIVATE
    ${ONEBENCH_LIBRARIES})

set_target_properties(onebench PROPERTIES
    BUILD_WITH_INSTALL_RPATH true
    INSTALL_RPATH_USE_LINK_PATH true
    INSTALL_RPATH "${CUSTOM_RPATH}")

install(TARGETS onebench DESTINATION ${CMAKE_INSTALL_FULL_BINDIR})

=== s3/CMakeLists.txt ===
find_package(GFlags REQUIRED)

include(../cmake/CPM.cmake)

CPMAddPackage(
        NAME drogon
        VERSION 1.8.2
        GITHUB_REPOSITORY bkryza/drogon
        GIT_TAG 505b15c96367d0ffc7ef7b54345c1aeb96807cb9
        OPTIONS "BUILD_SHARED_LIBS OFF" "BUILD_EXAMPLES OFF" "BUILD_ORM OFF" "BUILD_CTL OFF" "BUILD_BROTLI OFF"
)

set(ONES3_LIBRARIES
        libmacaroons-cpp
        ${PLATFORM_EXTRA_LIBS}
        ${FUSE_LIBRARIES}
        ${Boost_LIBRARIES}
        ${SODIUM_LIBRARIES}
        ${PROTOBUF_LIBRARIES}
        ${POCO_LIBRARIES}
        ${NSS_LIBRARIES}
        ${FOLLY_LIBRARIES}
        ${HELPERS_LIBRARIES}
        ${OPENSSL_LIBRARIES}
        gflags
        glog
        unwind
        drogon
        )

if(WITH_CEPH)
    list(APPEND ONES3_LIBRARIES ${RADOSSTRIPER_LIBRARY} ${RADOS_LIBRARY} ${CEPHCOMMON_LIBRARY})
endif(WITH_CEPH)

if(WITH_S3)
    list(APPEND ONES3_LIBRARIES ${AWS_SDK_LIBRARIES})
endif(WITH_S3)

if(WITH_SWIFT)
    list(APPEND ONES3_LIBRARIES ${SWIFT_SDK_LIBRARIES})
endif(WITH_SWIFT)

if(WITH_GLUSTERFS)
    list(APPEND ONES3_LIBRARIES ${GLUSTERFSAPI_LIBRARIES})
endif(WITH_GLUSTERFS)

if(WITH_XROOTD)
    list(APPEND ONES3_LIBRARIES ${XROOTD_LIBRARIES})
endif(WITH_XROOTD)

if(WITH_NFS)
    list(APPEND ONES3_LIBRARIES ${NFS_LIBRARIES})
endif(WITH_NFS)

include_directories(SYSTEM
        ${CMAKE_CURRENT_SOURCE_DIR}/../src
        ${drogon_SOURCE_DIR}/lib/src)

add_executable(ones3
        ones3.cc
        s3Server.cc
        serialization.cc
        s3Logic.cc
        s3LogicBucket.cc
        s3LogicFile.cc
        s3LogicMultipart.cc
        s3LogicObject.cc
        s3LogicCache.cc
        s3Server.cc
        s3Exception.cc
        restCommon.cc
        onepanelRestClient.cc
        oneproviderRestClient.cc
        onezoneRestClient.cc
        $<TARGET_OBJECTS:helpers>
        $<TARGET_OBJECTS:client>
        $<TARGET_OBJECTS:clproto>)

add_dependencies(ones3 helpers)

target_link_libraries(ones3 PRIVATE
        ${ONES3_LIBRARIES})

set_target_properties(ones3 PROPERTIES
        BUILD_WITH_INSTALL_RPATH true
        INSTALL_RPATH_USE_LINK_PATH true
        INSTALL_RPATH "${CUSTOM_RPATH}")

install(TARGETS ones3 DESTINATION ${CMAKE_INSTALL_FULL_BINDIR})

## oneclient-base 21.02.8.127.ge268bb0

=== debian/changelog ===
oneclient-base (21.02.8.127.ge268bb0-1~focal) focal; urgency=low

  * Build from 21.02.8.127.ge268bb0

 -- Onedata Package Maintainer <support@onedata.org>  Tue, 20 May 2025 23:06:34 +0200

## oneclient-base 21.02.8.137.gfe9c93a

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -8,4 +8,7 @@
 endif()
 
 add_subdirectory(unit)
+
+if(WITH_BENCHMARKS)
 add_subdirectory(benchmark)
+endif(WITH_BENCHMARKS)

=== debian/changelog ===
oneclient-base (21.02.8.137.gfe9c93a-1~focal) focal; urgency=low

  * Build from 21.02.8.137.gfe9c93a

 -- Onedata Package Maintainer <support@onedata.org>  Fri, 13 Jun 2025 20:01:51 +0200

=== debian/control ===
Source: oneclient-base
Section: net
Priority: optional
Maintainer: Onedata Package Maintainer <support@onedata.org>
Build-Depends:
    aws-sdk-cpp-s3 (>= 1.8.7),
    cmake (>= 3.0.0),
    debhelper (>= 9),
    folly-dev,
    g++ (>= 9.4.0),
    git,
    glusterfs-common (>= 7.2),
    libglusterfs-dev (>= 7.2),
    golang-go,
    libacl1-dev,
    libboost-all-dev,
    libcurl4-openssl-dev,
    libdouble-conversion-dev,
    libfuse3-dev (>= 3.6),
    libgoogle-glog-dev (>= 0.3.4),
    libiberty-dev,
    libjsoncpp-dev,
    libltdl-dev,
    libnspr4-dev,
    libnss3-dev,
    libprotobuf-dev (>= 3.4.1),
    libradospp-dev (>= 15.2.0),
    libradosstriper-dev (>= 15.2.0),
    libsodium-dev,
    libssl-dev (>= 1.1.0),
    libstdc++-9-dev,
    libtbb-dev,
    libpoco-dev,
    libpocofoundation62,
    libpoconetssl62,
    libpocoutil62,
    libpocoxml62,
    libxrootd-client-dev,
    libxrootd-server-dev,
    libxrootd-private-dev,
    openssl (>= 1.1.0),
    pkg-config,
    protobuf-compiler (>= 3.4.1),
    python3-dev,
    subversion,
    libunwind-dev,
    uuid-dev,
    wangle-dev,
    proxygen-dev,
    libfmt-dev (>= 7.0.1),
    libspdlog-dev (>= 1:1.7.0),
    libnfs-dev (>= 4.0.0)
Standards-Version: 3.9.5
Homepage: https://onedata.org

Package: oneclient-base
Architecture: amd64
Depends: glusterfs-common (>= 7.2), libnfs13 (>= 4.0.0), folly, libxrootd-client-dev, xrootd-plugins, xrootd-client-plugins, ${shlibs:Depends}, ${misc:Depends}, fuse3, libunwind8
Description: FUSE client for onedata system.
 Oneclient is a software based on FUSE (Filesystem in Userspace) that allows
 mounting onedata filesystem on Linux systems.

Package: python3-onedatafs
Architecture: amd64
Depends: python3, libboost-python1.71.0, libnfs13 (>= 4.0.0), folly, libxrootd-client-dev, xrootd-plugins, xrootd-client-plugins, libunwind8, ${shlibs:Depends}, ${misc:Depends}
Description: FUSE client for onedata system.
 oneclient is a software based on FUSE (Filesystem in Userspace) that allows
 mounting onedata filesystem on Linux systems.

## oneclient-base 21.02.8.142.gc9ccaf8

=== debian/changelog ===
oneclient-base (21.02.8.142.gc9ccaf8-1~focal) focal; urgency=low

  * Build from 21.02.8.142.gc9ccaf8

 -- Onedata Package Maintainer <support@onedata.org>  Fri, 04 Jul 2025 17:09:54 +0200

## oneclient-base 21.02.8.154.g1e69cff

=== test/benchmark/CMakeLists.txt ===
add_custom_target(benchmark)

if(FOLLY_SHARED)
    find_library(FOLLY_BENCHMARK_LIBRARIES NAMES libfollybenchmark.so)
else(FOLLY_SHARED)
    find_library(FOLLY_BENCHMARK_LIBRARIES NAMES libfollybenchmark.a)
endif(FOLLY_SHARED)

find_library(GFLAGS_LIBRARY gflags)

set(CLIENT_BENCHMARK_LIBRARIES
    libmacaroons-cpp
    ${PLATFORM_EXTRA_LIBS}
    ${FOLLY_LIBRARIES}
    ${GLOG_LIBRARY}
    ${GFLAGS_LIBRARY}
    ${FUSE_LIBRARIES}
    ${Boost_LIBRARIES}
    ${CLPROTO_LIBRARIES}
    ${TBB_LIBRARIES}
    ${SODIUM_LIBRARIES}
    ${PROTOBUF_LIBRARIES}
    ${NSS_LIBRARIES}
    ${OPENSSL_LIBRARIES}
    ${FOLLY_BENCHMARK_LIBRARIES}
    ${BACKWARD_CPP_LIBRARIES}
    ${POCO_LIBRARIES}
    )

add_library(clientBenchmarkShared SHARED ${CLIENT_SOURCES})

if(WITH_CEPH)
    list(APPEND CLIENT_BENCHMARK_LIBRARIES ${RADOS_LIBRARY} ${RADOSSTRIPER_LIBRARY})
endif(WITH_CEPH)

if(WITH_S3)
    list(APPEND CLIENT_BENCHMARK_LIBRARIES ${AWS_SDK_LIBRARIES})
endif(WITH_S3)

if(WITH_SWIFT)
    list(APPEND CLIENT_BENCHMARK_LIBRARIES ${SWIFT_SDK_LIBRARIES})
endif(WITH_SWIFT)

if(WITH_GLUSTERFS)
    list(APPEND CLIENT_BENCHMARK_LIBRARIES ${GLUSTERFSAPI_LIBRARIES})
endif(WITH_GLUSTERFS)

if(WITH_WEBDAV)
    list(APPEND CLIENT_BENCHMARK_LIBRARIES ${PROXYGEN_LIBRARY} ${WANGLE_LIBRARIES})
endif(WITH_WEBDAV)

if(WITH_XROOTD)
    list(APPEND CLIENT_BENCHMARK_LIBRARIES ${XROOTD_LIBRARIES})
endif(WITH_XROOTD)

if(WITH_NFS)
    list(APPEND CLIENT_BENCHMARK_LIBRARIES ${NFS_LIBRARIES})
endif(WITH_NFS)


list(APPEND CLIENT_BENCHMARK_LIBRARIES ${SPDLOG_LIBRARY} ${FMT_LIBRARY})

target_link_libraries(clientBenchmarkShared PUBLIC ${CLIENT_BENCHMARK_LIBRARIES})


file(GLOB_RECURSE TEST_SOURCES *_benchmark.cc)

foreach(TEST_SRC ${TEST_SOURCES})
    get_filename_component(TEST_NAME ${TEST_SRC} NAME_WE)
    add_executable(${TEST_NAME}
	    ${TEST_SRC}
	    ${TEST_HEADERS})
    target_link_libraries(${TEST_NAME} PRIVATE
        clientBenchmarkShared)
    add_custom_target(${TEST_NAME}_runbenchmark
        COMMAND ${TEST_NAME}
        WORKING_DIRECTORY ${CMAKE_BINARY_DIR})
    add_dependencies(benchmark ${TEST_NAME}_runbenchmark)
endforeach()

=== debian/changelog ===
oneclient-base (21.02.8.154.g1e69cff-1~focal) focal; urgency=low

  * Build from 21.02.8.154.g1e69cff

 -- Onedata Package Maintainer <support@onedata.org>  Tue, 26 Aug 2025 16:35:48 +0200

## oneclient-base 21.02.8.158.g1f1a15d

=== debian/changelog ===
oneclient-base (21.02.8.158.g1f1a15d-1~focal) focal; urgency=low

  * Build from 21.02.8.158.g1f1a15d

 -- Onedata Package Maintainer <support@onedata.org>  Wed, 27 Aug 2025 10:35:42 +0200

## oneclient-base 21.02.9

=== debian/changelog ===
oneclient-base (21.02.9-1~focal) focal; urgency=low

  * Build from 21.02.9

 -- Onedata Package Maintainer <support@onedata.org>  Wed, 10 Dec 2025 12:39:11 +0100
